diff --git a/gcc/tree-ssa-threadedge.c b/gcc/tree-ssa-threadedge.c
index 8e628d5..0bcc7ac 100644
--- a/gcc/tree-ssa-threadedge.c
+++ b/gcc/tree-ssa-threadedge.c
@@ -116,10 +116,10 @@ potentially_threadable_block (basic_block bb)
    BB.  If no such ASSERT_EXPR is found, return OP.  */
 
 static tree
-lhs_of_dominating_assert (tree op, basic_block bb, gimple stmt)
+lhs_of_dominating_assert (tree op, basic_block bb, gimple *stmt)
 {
   imm_use_iterator imm_iter;
-  gimple use_stmt;
+  gimple *use_stmt;
   use_operand_p use_p;
 
   FOR_EACH_IMM_USE_FAST (use_p, imm_iter, op)
@@ -210,7 +210,7 @@ record_temporary_equivalences_from_phis (edge e, vec<tree> *stack,
      later.  */
   for (gsi = gsi_start_phis (e->dest); !gsi_end_p (gsi); gsi_next (&gsi))
     {
-      gimple phi = gsi_stmt (gsi);
+      gimple *phi = gsi_stmt (gsi);
       tree src = PHI_ARG_DEF_FROM_EDGE (phi, e);
       tree dst = gimple_phi_result (phi);
 
@@ -245,7 +245,7 @@ record_temporary_equivalences_from_phis (edge e, vec<tree> *stack,
    May return NULL_TREE if no simplification is possible.  */
 
 static tree
-fold_assignment_stmt (gimple stmt)
+fold_assignment_stmt (gimple *stmt)
 {
   enum tree_code subcode = gimple_assign_rhs_code (stmt);
 
@@ -336,16 +336,16 @@ invalidate_equivalences (tree lhs, vec<tree> *stack,
    a context sensitive equivalence which may help us simplify
    later statements in E->dest.  */
 
-static gimple
+static gimple *
 record_temporary_equivalences_from_stmts_at_dest (edge e,
 						  vec<tree> *stack,
-						  tree (*simplify) (gimple,
-								    gimple),
+						  tree (*simplify) (gimple *,
+								    gimple *),
 						  bool backedge_seen,
 						  bitmap src_map,
 						  bitmap dst_map)
 {
-  gimple stmt = NULL;
+  gimple *stmt = NULL;
   gimple_stmt_iterator gsi;
   int max_stmt_count;
 
@@ -544,7 +544,7 @@ record_temporary_equivalences_from_stmts_at_dest (edge e,
    necessarily valid.  We use this callback rather than the ones provided by
    DOM/VRP to achieve that effect.  */
 static tree
-dummy_simplify (gimple stmt1 ATTRIBUTE_UNUSED, gimple stmt2 ATTRIBUTE_UNUSED)
+dummy_simplify (gimple *stmt1 ATTRIBUTE_UNUSED, gimple *stmt2 ATTRIBUTE_UNUSED)
 {
   return NULL_TREE;
 }
@@ -562,9 +562,9 @@ dummy_simplify (gimple stmt1 ATTRIBUTE_UNUSED, gimple stmt2 ATTRIBUTE_UNUSED)
 
 static tree
 simplify_control_stmt_condition (edge e,
-				 gimple stmt,
-				 gimple dummy_cond,
-				 tree (*simplify) (gimple, gimple),
+				 gimple *stmt,
+				 gimple *dummy_cond,
+				 tree (*simplify) (gimple *, gimple *),
 				 bool handle_dominating_asserts)
 {
   tree cond, cached_lhs;
@@ -711,7 +711,7 @@ propagate_threaded_block_debug_into (basic_block dest, basic_block src)
   for (gimple_stmt_iterator si = gsi;
        i * 4 <= alloc_count * 3 && !gsi_end_p (si); gsi_next (&si))
     {
-      gimple stmt = gsi_stmt (si);
+      gimple *stmt = gsi_stmt (si);
       if (!is_gimple_debug (stmt))
 	break;
       i++;
@@ -731,7 +731,7 @@ propagate_threaded_block_debug_into (basic_block dest, basic_block src)
      duplicates in FEWVARS.  */
   for (gimple_stmt_iterator si = gsi; !gsi_end_p (si); gsi_next (&si))
     {
-      gimple stmt = gsi_stmt (si);
+      gimple *stmt = gsi_stmt (si);
       if (!is_gimple_debug (stmt))
 	break;
 
@@ -758,7 +758,7 @@ propagate_threaded_block_debug_into (basic_block dest, basic_block src)
       for (gimple_stmt_iterator si = gsi_last_bb (bb);
 	   !gsi_end_p (si); gsi_prev (&si))
 	{
-	  gimple stmt = gsi_stmt (si);
+	  gimple *stmt = gsi_stmt (si);
 	  if (!is_gimple_debug (stmt))
 	    continue;
 
@@ -827,16 +827,16 @@ propagate_threaded_block_debug_into (basic_block dest, basic_block src)
    try and simplify the condition at the end of TAKEN_EDGE->dest.  */
 static bool
 thread_around_empty_blocks (edge taken_edge,
-			    gimple dummy_cond,
+			    gimple *dummy_cond,
 			    bool handle_dominating_asserts,
-			    tree (*simplify) (gimple, gimple),
+			    tree (*simplify) (gimple *, gimple *),
 			    bitmap visited,
 			    vec<jump_thread_edge *> *path,
 			    bool *backedge_seen_p)
 {
   basic_block bb = taken_edge->dest;
   gimple_stmt_iterator gsi;
-  gimple stmt;
+  gimple *stmt;
   tree cond;
 
   /* The key property of these blocks is that they need not be duplicated
@@ -975,10 +975,10 @@ thread_around_empty_blocks (edge taken_edge,
 
 static int
 thread_through_normal_block (edge e,
-			     gimple dummy_cond,
+			     gimple *dummy_cond,
 			     bool handle_dominating_asserts,
 			     vec<tree> *stack,
-			     tree (*simplify) (gimple, gimple),
+			     tree (*simplify) (gimple *, gimple *),
 			     vec<jump_thread_edge *> *path,
 			     bitmap visited,
 			     bool *backedge_seen_p,
@@ -999,7 +999,7 @@ thread_through_normal_block (edge e,
 
   /* Now walk each statement recording any context sensitive
      temporary equivalences we can detect.  */
-  gimple stmt
+  gimple *stmt
     = record_temporary_equivalences_from_stmts_at_dest (e, stack, simplify,
 							*backedge_seen_p,
 							src_map, dst_map);
@@ -1104,11 +1104,11 @@ thread_through_normal_block (edge e,
    SIMPLIFY is a pass-specific function used to simplify statements.  */
 
 void
-thread_across_edge (gimple dummy_cond,
+thread_across_edge (gimple *dummy_cond,
 		    edge e,
 		    bool handle_dominating_asserts,
 		    vec<tree> *stack,
-		    tree (*simplify) (gimple, gimple))
+		    tree (*simplify) (gimple *, gimple *))
 {
   bitmap visited = BITMAP_ALLOC (NULL);
   bitmap src_map = BITMAP_ALLOC (NULL);
diff --git a/gcc/tree-ssa-threadedge.h b/gcc/tree-ssa-threadedge.h
index f005607..d4ae281 100644
--- a/gcc/tree-ssa-threadedge.h
+++ b/gcc/tree-ssa-threadedge.h
@@ -30,7 +30,7 @@ extern void threadedge_initialize_values (void);
 extern void threadedge_finalize_values (void);
 extern bool potentially_threadable_block (basic_block);
 extern void propagate_threaded_block_debug_into (basic_block, basic_block);
-extern void thread_across_edge (gimple, edge, bool,
-				vec<tree> *, tree (*) (gimple, gimple));
+extern void thread_across_edge (gimple *, edge, bool,
+				vec<tree> *, tree (*) (gimple *, gimple *));
 
 #endif /* GCC_TREE_SSA_THREADEDGE_H */
diff --git a/gcc/tree-ssa-threadupdate.c b/gcc/tree-ssa-threadupdate.c
index 0a24a5c..5e28965 100644
--- a/gcc/tree-ssa-threadupdate.c
+++ b/gcc/tree-ssa-threadupdate.c
@@ -393,8 +393,8 @@ copy_phi_arg_into_existing_phi (edge src_e, edge tgt_e)
        !gsi_end_p (gsi);
        gsi_next (&gsi), gsi_next (&gsi2))
     {
-      gimple src_phi = gsi_stmt (gsi);
-      gimple dest_phi = gsi_stmt (gsi2);
+      gimple *src_phi = gsi_stmt (gsi);
+      gimple *dest_phi = gsi_stmt (gsi2);
       tree val = gimple_phi_arg_def (src_phi, src_idx);
       source_location locus = gimple_phi_arg_location (src_phi, src_idx);
 
@@ -413,7 +413,7 @@ get_value_locus_in_path (tree def, vec<jump_thread_edge *> *path,
 			 basic_block bb, int idx, source_location *locus)
 {
   tree arg;
-  gimple def_phi;
+  gimple *def_phi;
   basic_block def_bb;
 
   if (path == NULL || idx == 0)
@@ -462,7 +462,7 @@ copy_phi_args (basic_block bb, edge src_e, edge tgt_e,
 
   for (gsi = gsi_start_phis (bb); !gsi_end_p (gsi); gsi_next (&gsi))
     {
-      gimple phi = gsi_stmt (gsi);
+      gimple *phi = gsi_stmt (gsi);
       tree def = gimple_phi_arg_def (phi, src_indx);
       source_location locus = gimple_phi_arg_location (phi, src_indx);
 
@@ -1461,7 +1461,7 @@ phi_args_equal_on_edges (edge e1, edge e2)
 
   for (gsi = gsi_start_phis (e1->dest); !gsi_end_p (gsi); gsi_next (&gsi))
     {
-      gimple phi = gsi_stmt (gsi);
+      gimple *phi = gsi_stmt (gsi);
 
       if (!operand_equal_p (gimple_phi_arg_def (phi, indx1),
 			    gimple_phi_arg_def (phi, indx2), 0))
@@ -1678,7 +1678,7 @@ mark_threaded_blocks (bitmap threaded_blocks)
 static bool
 bb_ends_with_multiway_branch (basic_block bb ATTRIBUTE_UNUSED)
 {
-  gimple stmt = last_stmt (bb);
+  gimple *stmt = last_stmt (bb);
   if (stmt && gimple_code (stmt) == GIMPLE_SWITCH)
     return true;
   if (stmt && gimple_code (stmt) == GIMPLE_GOTO
diff --git a/gcc/tree-ssa-uncprop.c b/gcc/tree-ssa-uncprop.c
index 7342c9d..4c196e1 100644
--- a/gcc/tree-ssa-uncprop.c
+++ b/gcc/tree-ssa-uncprop.c
@@ -68,7 +68,7 @@ associate_equivalences_with_edges (void)
   FOR_EACH_BB_FN (bb, cfun)
     {
       gimple_stmt_iterator gsi = gsi_last_bb (bb);
-      gimple stmt;
+      gimple *stmt;
 
       /* If the block does not end with a COND_EXPR or SWITCH_EXPR
 	 then there is nothing to do.  */
@@ -430,7 +430,7 @@ uncprop_into_successor_phis (basic_block bb)
       /* Walk over the PHI nodes, unpropagating values.  */
       for (gsi = gsi_start (phis) ; !gsi_end_p (gsi); gsi_next (&gsi))
 	{
-	  gimple phi = gsi_stmt (gsi);
+	  gimple *phi = gsi_stmt (gsi);
 	  tree arg = PHI_ARG_DEF (phi, e->dest_idx);
 	  tree res = PHI_RESULT (phi);
 	  equiv_hash_elt an_equiv_elt;
diff --git a/gcc/tree-ssa-uninit.c b/gcc/tree-ssa-uninit.c
index 8b298fa..8ae8d78 100644
--- a/gcc/tree-ssa-uninit.c
+++ b/gcc/tree-ssa-uninit.c
@@ -132,7 +132,7 @@ static void
 warn_uninit (enum opt_code wc, tree t, tree expr, tree var,
 	     const char *gmsgid, void *data, location_t phiarg_loc)
 {
-  gimple context = (gimple) data;
+  gimple *context = (gimple *) data;
   location_t location, cfun_loc;
   expanded_location xloc, floc;
 
@@ -194,7 +194,7 @@ warn_uninitialized_vars (bool warn_possibly_uninitialized)
 					     single_succ (ENTRY_BLOCK_PTR_FOR_FN (cfun)), bb);
       for (gsi = gsi_start_bb (bb); !gsi_end_p (gsi); gsi_next (&gsi))
 	{
-	  gimple stmt = gsi_stmt (gsi);
+	  gimple *stmt = gsi_stmt (gsi);
 	  use_operand_p use_p;
 	  ssa_op_iter op_iter;
 	  tree use;
@@ -267,9 +267,9 @@ warn_uninitialized_vars (bool warn_possibly_uninitialized)
    redundant. Can be enhanced to be more general.  */
 
 static bool
-can_skip_redundant_opnd (tree opnd, gimple phi)
+can_skip_redundant_opnd (tree opnd, gimple *phi)
 {
-  gimple op_def;
+  gimple *op_def;
   tree phi_def;
   int i, n;
 
@@ -294,7 +294,7 @@ can_skip_redundant_opnd (tree opnd, gimple phi)
    that have empty (or possibly empty) definitions.  */
 
 static unsigned
-compute_uninit_opnds_pos (gimple phi)
+compute_uninit_opnds_pos (gimple *phi)
 {
   size_t i, n;
   unsigned uninit_opnds = 0;
@@ -539,7 +539,7 @@ convert_control_dep_chain_into_preds (vec<edge> *dep_chains,
       pred_chain t_chain = vNULL;
       for (j = 0; j < one_cd_chain.length (); j++)
         {
-          gimple cond_stmt;
+          gimple *cond_stmt;
           gimple_stmt_iterator gsi;
           basic_block guard_bb;
           pred_info one_pred;
@@ -646,7 +646,7 @@ find_predicates (pred_chain_union *preds,
    VISITED_PHIS is a pointer set for detecting cycles.  */
 
 static void
-collect_phi_def_edges (gimple phi, basic_block cd_root,
+collect_phi_def_edges (gimple *phi, basic_block cd_root,
                        vec<edge> *edges,
                        pointer_set_t *visited_phis)
 {
@@ -674,7 +674,7 @@ collect_phi_def_edges (gimple phi, basic_block cd_root,
         }
       else
         {
-          gimple def = SSA_NAME_DEF_STMT (opnd);
+          gimple *def = SSA_NAME_DEF_STMT (opnd);
 
           if (gimple_code (def) == GIMPLE_PHI
               && dominated_by_p (CDI_DOMINATORS,
@@ -699,7 +699,7 @@ collect_phi_def_edges (gimple phi, basic_block cd_root,
    composite predicates pointed to by PREDS.  */
 
 static bool
-find_def_preds (pred_chain_union *preds, gimple phi)
+find_def_preds (pred_chain_union *preds, gimple *phi)
 {
   size_t num_chains = 0, i, n;
   vec<edge> dep_chains[MAX_NUM_CHAINS];
@@ -756,7 +756,7 @@ find_def_preds (pred_chain_union *preds, gimple phi)
 /* Dumps the predicates (PREDS) for USESTMT.  */
 
 static void
-dump_predicates (gimple usestmt, pred_chain_union preds,
+dump_predicates (gimple *usestmt, pred_chain_union preds,
                  const char* msg)
 {
   size_t i, j;
@@ -937,9 +937,9 @@ find_matching_predicate_in_rest_chains (pred_info pred,
 
 /* Forward declaration.  */
 static bool
-is_use_properly_guarded (gimple use_stmt,
+is_use_properly_guarded (gimple *use_stmt,
                          basic_block use_bb,
-                         gimple phi,
+                         gimple *phi,
                          unsigned uninit_opnds,
                          pointer_set_t *visited_phis);
 
@@ -978,9 +978,9 @@ is_use_properly_guarded (gimple use_stmt,
 */
 
 static bool
-prune_uninit_phi_opnds_in_unrealizable_paths (gimple phi,
+prune_uninit_phi_opnds_in_unrealizable_paths (gimple *phi,
 					      unsigned uninit_opnds,
-					      gimple flag_def,
+					      gimple *flag_def,
 					      tree boundary_cst,
 					      enum tree_code cmp_code,
 					      pointer_set_t *visited_phis,
@@ -998,7 +998,7 @@ prune_uninit_phi_opnds_in_unrealizable_paths (gimple phi,
       flag_arg = gimple_phi_arg_def (flag_def, i);
       if (!is_gimple_constant (flag_arg))
         {
-          gimple flag_arg_def, phi_arg_def;
+          gimple *flag_arg_def, *phi_arg_def;
           tree phi_arg;
           unsigned uninit_opnds_arg_phi;
 
@@ -1045,7 +1045,7 @@ prune_uninit_phi_opnds_in_unrealizable_paths (gimple phi,
       if (is_value_included_in (flag_arg, boundary_cst, cmp_code))
         {
           tree opnd;
-          gimple opnd_def;
+          gimple *opnd_def;
 
           /* Now that we know that this undefined edge is not
              pruned. If the operand is defined by another phi,
@@ -1152,11 +1152,11 @@ prune_uninit_phi_opnds_in_unrealizable_paths (gimple phi,
 
 static bool
 use_pred_not_overlap_with_undef_path_pred (pred_chain_union preds,
-				           gimple phi, unsigned uninit_opnds,
+				           gimple *phi, unsigned uninit_opnds,
 					   pointer_set_t *visited_phis)
 {
   unsigned int i, n;
-  gimple flag_def = 0;
+  gimple *flag_def = 0;
   tree  boundary_cst = 0;
   enum tree_code cmp_code;
   bool swap_cond = false;
@@ -1473,7 +1473,7 @@ simplify_pred (pred_chain *one_chain)
       if (!is_neq_zero_form_p (*a_pred))
         continue;
 
-      gimple def_stmt = SSA_NAME_DEF_STMT (a_pred->pred_lhs);
+      gimple *def_stmt = SSA_NAME_DEF_STMT (a_pred->pred_lhs);
       if (gimple_code (def_stmt) != GIMPLE_ASSIGN)
         continue;
       if (gimple_assign_rhs_code (def_stmt) == BIT_IOR_EXPR)
@@ -1662,7 +1662,7 @@ simplify_preds_4 (pred_chain_union *preds)
   size_t i, j, n;
   bool simplified = false;
   pred_chain_union s_preds = vNULL;
-  gimple def_stmt;
+  gimple *def_stmt;
 
   n = preds->length ();
   for (i = 0; i < n; i++)
@@ -1736,7 +1736,7 @@ simplify_preds_4 (pred_chain_union *preds)
 /* This function simplifies predicates in PREDS.  */
 
 static void
-simplify_preds (pred_chain_union *preds, gimple use_or_def, bool is_use)
+simplify_preds (pred_chain_union *preds, gimple *use_or_def, bool is_use)
 {
   size_t i, n;
   bool changed = false;
@@ -1836,7 +1836,7 @@ push_to_worklist (tree op, vec<pred_info, va_heap, vl_ptr> *work_list,
    CMP_ASSIGN with comparison rhs.  */
 
 static pred_info
-get_pred_info_from_cmp (gimple cmp_assign)
+get_pred_info_from_cmp (gimple *cmp_assign)
 {
   pred_info n_pred;
   n_pred.pred_lhs = gimple_assign_rhs1 (cmp_assign);
@@ -1851,11 +1851,11 @@ get_pred_info_from_cmp (gimple cmp_assign)
    will be updated to that value.  */
 
 static bool
-is_degenerated_phi (gimple phi, pred_info *pred_p)
+is_degenerated_phi (gimple *phi, pred_info *pred_p)
 {
   int i, n;
   tree op0;
-  gimple def0;
+  gimple *def0;
   pred_info pred0;
 
   n = gimple_phi_num_args (phi);
@@ -1874,7 +1874,7 @@ is_degenerated_phi (gimple phi, pred_info *pred_p)
 
   for (i = 1; i < n; ++i)
     {
-      gimple def;
+      gimple *def;
       pred_info pred;
       tree op = gimple_phi_arg_def (phi, i);
 
@@ -1918,7 +1918,7 @@ normalize_one_pred_1 (pred_chain_union *norm_preds,
       return;
     }
 
-  gimple def_stmt = SSA_NAME_DEF_STMT (pred.pred_lhs);
+  gimple *def_stmt = SSA_NAME_DEF_STMT (pred.pred_lhs);
  
   if (gimple_code (def_stmt) == GIMPLE_PHI
       && is_degenerated_phi (def_stmt, &pred))
@@ -1997,7 +1997,7 @@ normalize_one_pred (pred_chain_union *norm_preds,
       return;
     }
 
-  gimple def_stmt = SSA_NAME_DEF_STMT (pred.pred_lhs);
+  gimple *def_stmt = SSA_NAME_DEF_STMT (pred.pred_lhs);
   if (gimple_code (def_stmt) == GIMPLE_ASSIGN)
     and_or_code = gimple_assign_rhs_code (def_stmt);
   if (and_or_code != BIT_IOR_EXPR
@@ -2060,7 +2060,7 @@ normalize_one_pred_chain (pred_chain_union *norm_preds,
 /* Normalize predicate chains PREDS and returns the normalized one.  */
 
 static pred_chain_union
-normalize_preds (pred_chain_union preds, gimple use_or_def, bool is_use)
+normalize_preds (pred_chain_union preds, gimple *use_or_def, bool is_use)
 {
   pred_chain_union norm_preds = vNULL;
   size_t n = preds.length ();
@@ -2108,9 +2108,9 @@ normalize_preds (pred_chain_union preds, gimple use_or_def, bool is_use)
    set of phis being visted.  */
 
 static bool
-is_use_properly_guarded (gimple use_stmt,
+is_use_properly_guarded (gimple *use_stmt,
                          basic_block use_bb,
-                         gimple phi,
+                         gimple *phi,
                          unsigned uninit_opnds,
                          pointer_set_t *visited_phis)
 {
@@ -2178,14 +2178,14 @@ is_use_properly_guarded (gimple use_stmt,
    function. ADDED_TO_WORKLIST is the pointer set tracking
    if the new phi is already in the worklist.  */
 
-static gimple
-find_uninit_use (gimple phi, unsigned uninit_opnds,
-                 vec<gimple> *worklist,
+static gimple *
+find_uninit_use (gimple *phi, unsigned uninit_opnds,
+                 vec<gimple *> *worklist,
 		 pointer_set_t *added_to_worklist)
 {
   tree phi_result;
   use_operand_p use_p;
-  gimple use_stmt;
+  gimple *use_stmt;
   imm_use_iterator iter;
 
   phi_result = gimple_phi_result (phi);
@@ -2251,11 +2251,11 @@ find_uninit_use (gimple phi, unsigned uninit_opnds,
    a pointer set tracking if the new phi is added to the worklist or not.  */
 
 static void
-warn_uninitialized_phi (gimple phi, vec<gimple> *worklist,
+warn_uninitialized_phi (gimple *phi, vec<gimple *> *worklist,
                         pointer_set_t *added_to_worklist)
 {
   unsigned uninit_opnds;
-  gimple uninit_use_stmt = 0;
+  gimple *uninit_use_stmt = 0;
   tree uninit_op;
   int phiarg_index;
   location_t loc;
@@ -2339,7 +2339,7 @@ pass_late_warn_uninitialized::execute (function *fun)
 {
   basic_block bb;
   gimple_stmt_iterator gsi;
-  vec<gimple> worklist = vNULL;
+  vec<gimple *> worklist = vNULL;
   pointer_set_t *added_to_worklist;
 
   calculate_dominance_info (CDI_DOMINATORS);
@@ -2358,7 +2358,7 @@ pass_late_warn_uninitialized::execute (function *fun)
   FOR_EACH_BB_FN (bb, fun)
     for (gsi = gsi_start_phis (bb); !gsi_end_p (gsi); gsi_next (&gsi))
       {
-	gimple phi = gsi_stmt (gsi);
+	gimple *phi = gsi_stmt (gsi);
 	size_t n, i;
 
 	n = gimple_phi_num_args (phi);
@@ -2387,7 +2387,7 @@ pass_late_warn_uninitialized::execute (function *fun)
 
   while (worklist.length () != 0)
     {
-      gimple cur_phi = 0;
+      gimple *cur_phi = 0;
       cur_phi = worklist.pop ();
       warn_uninitialized_phi (cur_phi, &worklist, added_to_worklist);
     }
diff --git a/gcc/tree-ssa.c b/gcc/tree-ssa.c
index 42a2783..a4fcb62 100644
--- a/gcc/tree-ssa.c
+++ b/gcc/tree-ssa.c
@@ -190,7 +190,7 @@ edge
 ssa_redirect_edge (edge e, basic_block dest)
 {
   gimple_stmt_iterator gsi;
-  gimple phi;
+  gimple *phi;
 
   redirect_edge_var_map_clear (e);
 
@@ -222,7 +222,7 @@ ssa_redirect_edge (edge e, basic_block dest)
 void
 flush_pending_stmts (edge e)
 {
-  gimple phi;
+  gimple *phi;
   edge_var_map_vector *v;
   edge_var_map *vm;
   int i;
@@ -266,7 +266,7 @@ flush_pending_stmts (edge e)
    copying and removing.  */
 
 void
-gimple_replace_ssa_lhs (gimple stmt, tree nlhs)
+gimple_replace_ssa_lhs (gimple *stmt, tree nlhs)
 {
   if (MAY_HAVE_DEBUG_STMTS)
     {
@@ -351,8 +351,8 @@ insert_debug_temp_for_var_def (gimple_stmt_iterator *gsi, tree var)
 {
   imm_use_iterator imm_iter;
   use_operand_p use_p;
-  gimple stmt;
-  gimple def_stmt = NULL;
+  gimple *stmt;
+  gimple *def_stmt = NULL;
   int usecount = 0;
   tree value = NULL;
 
@@ -477,7 +477,7 @@ insert_debug_temp_for_var_def (gimple_stmt_iterator *gsi, tree var)
 	;
       else
 	{
-	  gimple def_temp;
+	  gimple *def_temp;
 	  tree vexpr = make_node (DEBUG_EXPR_DECL);
 
 	  def_temp = gimple_build_debug_bind (vexpr,
@@ -540,7 +540,7 @@ insert_debug_temp_for_var_def (gimple_stmt_iterator *gsi, tree var)
 void
 insert_debug_temps_for_defs (gimple_stmt_iterator *gsi)
 {
-  gimple stmt;
+  gimple *stmt;
   ssa_op_iter op_iter;
   def_operand_p def_p;
 
@@ -563,12 +563,12 @@ insert_debug_temps_for_defs (gimple_stmt_iterator *gsi)
 /* Reset all debug stmts that use SSA_NAME(s) defined in STMT.  */
 
 void
-reset_debug_uses (gimple stmt)
+reset_debug_uses (gimple *stmt)
 {
   ssa_op_iter op_iter;
   def_operand_p def_p;
   imm_use_iterator imm_iter;
-  gimple use_stmt;
+  gimple *use_stmt;
 
   if (!MAY_HAVE_DEBUG_STMTS)
     return;
@@ -609,7 +609,7 @@ release_defs_bitset (bitmap toremove)
       {
 	bool remove_now = true;
 	tree var = ssa_name (j);
-	gimple stmt;
+	gimple *stmt;
 	imm_use_iterator uit;
 
 	FOR_EACH_IMM_USE_STMT (stmt, uit, var)
@@ -643,7 +643,7 @@ release_defs_bitset (bitmap toremove)
 
 	if (remove_now)
 	  {
-	    gimple def = SSA_NAME_DEF_STMT (var);
+	    gimple *def = SSA_NAME_DEF_STMT (var);
 	    gimple_stmt_iterator gsi = gsi_for_stmt (def);
 
 	    if (gimple_code (def) == GIMPLE_PHI)
@@ -728,7 +728,7 @@ verify_ssa_name (tree ssa_name, bool is_virtual)
 
 static bool
 verify_def (basic_block bb, basic_block *definition_block, tree ssa_name,
-	    gimple stmt, bool is_virtual)
+	    gimple *stmt, bool is_virtual)
 {
   if (verify_ssa_name (ssa_name, is_virtual))
     goto err;
@@ -788,7 +788,7 @@ err:
 
 static bool
 verify_use (basic_block bb, basic_block def_bb, use_operand_p use_p,
-	    gimple stmt, bool check_abnormal, bitmap names_defined_in_bb)
+	    gimple *stmt, bool check_abnormal, bitmap names_defined_in_bb)
 {
   bool err = false;
   tree ssa_name = USE_FROM_PTR (use_p);
@@ -871,7 +871,7 @@ verify_use (basic_block bb, basic_block def_bb, use_operand_p use_p,
       definition of SSA_NAME.  */
 
 static bool
-verify_phi_args (gimple phi, basic_block bb, basic_block *definition_block)
+verify_phi_args (gimple *phi, basic_block bb, basic_block *definition_block)
 {
   edge e;
   bool err = false;
@@ -979,7 +979,7 @@ verify_ssa (bool check_modified_stmt, bool check_ssa_operands)
       tree name = ssa_name (i);
       if (name)
 	{
-	  gimple stmt;
+	  gimple *stmt;
 	  TREE_VISITED (name) = 0;
 
 	  verify_ssa_name (name, virtual_operand_p (name));
@@ -1002,7 +1002,7 @@ verify_ssa (bool check_modified_stmt, bool check_ssa_operands)
   FOR_EACH_BB_FN (bb, cfun)
     {
       edge e;
-      gimple phi;
+      gimple *phi;
       edge_iterator ei;
       gimple_stmt_iterator gsi;
 
@@ -1031,7 +1031,7 @@ verify_ssa (bool check_modified_stmt, bool check_ssa_operands)
       /* Now verify all the uses and vuses in every statement of the block.  */
       for (gsi = gsi_start_bb (bb); !gsi_end_p (gsi); gsi_next (&gsi))
 	{
-	  gimple stmt = gsi_stmt (gsi);
+	  gimple *stmt = gsi_stmt (gsi);
 	  use_operand_p use_p;
 
 	  if (check_modified_stmt && gimple_modified_p (stmt))
@@ -1246,7 +1246,7 @@ tree_ssa_strip_useless_type_conversions (tree exp)
 bool
 ssa_undefined_value_p (tree t)
 {
-  gimple def_stmt;
+  gimple *def_stmt;
   tree var = SSA_NAME_VAR (t);
 
   if (!var)
@@ -1474,7 +1474,7 @@ execute_update_addresses_taken (void)
     {
       for (gsi = gsi_start_bb (bb); !gsi_end_p (gsi); gsi_next (&gsi))
 	{
-	  gimple stmt = gsi_stmt (gsi);
+	  gimple *stmt = gsi_stmt (gsi);
 	  enum gimple_code code = gimple_code (stmt);
 	  tree decl;
 
@@ -1544,7 +1544,7 @@ execute_update_addresses_taken (void)
       for (gsi = gsi_start_phis (bb); !gsi_end_p (gsi); gsi_next (&gsi))
 	{
 	  size_t i;
-	  gimple phi = gsi_stmt (gsi);
+	  gimple *phi = gsi_stmt (gsi);
 
 	  for (i = 0; i < gimple_phi_num_args (phi); i++)
 	    {
@@ -1575,7 +1575,7 @@ execute_update_addresses_taken (void)
       FOR_EACH_BB_FN (bb, cfun)
 	for (gsi = gsi_start_bb (bb); !gsi_end_p (gsi);)
 	  {
-	    gimple stmt = gsi_stmt (gsi);
+	    gimple *stmt = gsi_stmt (gsi);
 
 	    /* Re-write TARGET_MEM_REFs of symbols we want to
 	       rewrite into SSA form.  */
diff --git a/gcc/tree-ssa.h b/gcc/tree-ssa.h
index c866206..fc591f6 100644
--- a/gcc/tree-ssa.h
+++ b/gcc/tree-ssa.h
@@ -39,11 +39,11 @@ extern edge_var_map_vector *redirect_edge_var_map_vector (edge);
 extern void redirect_edge_var_map_destroy (void);
 extern edge ssa_redirect_edge (edge, basic_block);
 extern void flush_pending_stmts (edge);
-extern void gimple_replace_ssa_lhs (gimple, tree);
+extern void gimple_replace_ssa_lhs (gimple *, tree);
 extern tree target_for_debug_bind (tree);
 extern void insert_debug_temp_for_var_def (gimple_stmt_iterator *, tree);
 extern void insert_debug_temps_for_defs (gimple_stmt_iterator *);
-extern void reset_debug_uses (gimple);
+extern void reset_debug_uses (gimple *);
 extern void release_defs_bitset (bitmap toremove);
 extern void verify_ssa (bool, bool);
 extern void init_tree_ssa (struct function *);
diff --git a/gcc/tree-ssanames.c b/gcc/tree-ssanames.c
index 20a2c3f..90e737e 100644
--- a/gcc/tree-ssanames.c
+++ b/gcc/tree-ssanames.c
@@ -125,7 +125,7 @@ ssanames_print_statistics (void)
    used without a preceding definition).  */
 
 tree
-make_ssa_name_fn (struct function *fn, tree var, gimple stmt)
+make_ssa_name_fn (struct function *fn, tree var, gimple *stmt)
 {
   tree t;
   use_operand_p imm;
@@ -442,7 +442,7 @@ get_ptr_info (tree t)
    statement STMT in function FN.  */
 
 tree
-copy_ssa_name_fn (struct function *fn, tree name, gimple stmt)
+copy_ssa_name_fn (struct function *fn, tree name, gimple *stmt)
 {
   tree new_name;
 
@@ -510,7 +510,7 @@ duplicate_ssa_name_range_info (tree name, enum value_range_type range_type,
    in function FN.  */
 
 tree
-duplicate_ssa_name_fn (struct function *fn, tree name, gimple stmt)
+duplicate_ssa_name_fn (struct function *fn, tree name, gimple *stmt)
 {
   tree new_name = copy_ssa_name_fn (fn, name, stmt);
   if (POINTER_TYPE_P (TREE_TYPE (name)))
@@ -536,7 +536,7 @@ duplicate_ssa_name_fn (struct function *fn, tree name, gimple stmt)
 /* Release all the SSA_NAMEs created by STMT.  */
 
 void
-release_defs (gimple stmt)
+release_defs (gimple *stmt)
 {
   tree def;
   ssa_op_iter iter;
diff --git a/gcc/tree-ssanames.h b/gcc/tree-ssanames.h
index 4fc9f69..3aa0ac6 100644
--- a/gcc/tree-ssanames.h
+++ b/gcc/tree-ssanames.h
@@ -79,7 +79,7 @@ extern wide_int get_nonzero_bits (const_tree);
 extern void init_ssanames (struct function *, int);
 extern void fini_ssanames (void);
 extern void ssanames_print_statistics (void);
-extern tree make_ssa_name_fn (struct function *, tree, gimple);
+extern tree make_ssa_name_fn (struct function *, tree, gimple *);
 extern void release_ssa_name_fn (struct function *, tree);
 extern bool get_ptr_info_alignment (struct ptr_info_def *, unsigned int *,
 				    unsigned int *);
@@ -90,12 +90,12 @@ extern void adjust_ptr_info_misalignment (struct ptr_info_def *,
 					  unsigned int);
 extern struct ptr_info_def *get_ptr_info (tree);
 
-extern tree copy_ssa_name_fn (struct function *, tree, gimple);
+extern tree copy_ssa_name_fn (struct function *, tree, gimple *);
 extern void duplicate_ssa_name_ptr_info (tree, struct ptr_info_def *);
-extern tree duplicate_ssa_name_fn (struct function *, tree, gimple);
+extern tree duplicate_ssa_name_fn (struct function *, tree, gimple *);
 extern void duplicate_ssa_name_range_info (tree, enum value_range_type,
 					   struct range_info_def *);
-extern void release_defs (gimple);
+extern void release_defs (gimple *);
 extern void replace_ssa_name_symbol (tree, tree);
 
 
@@ -103,7 +103,7 @@ extern void replace_ssa_name_symbol (tree, tree);
    in function cfun.  */
 
 static inline tree
-make_ssa_name (tree var, gimple stmt)
+make_ssa_name (tree var, gimple *stmt)
 {
   return make_ssa_name_fn (cfun, var, stmt);
 }
@@ -112,7 +112,7 @@ make_ssa_name (tree var, gimple stmt)
    statement STMT in function cfun.  */
 
 static inline tree
-copy_ssa_name (tree var, gimple stmt)
+copy_ssa_name (tree var, gimple *stmt)
 {
   return copy_ssa_name_fn (cfun, var, stmt);
 }
@@ -121,7 +121,7 @@ copy_ssa_name (tree var, gimple stmt)
     in function cfun.  */
 
 static inline tree
-duplicate_ssa_name (tree var, gimple stmt)
+duplicate_ssa_name (tree var, gimple *stmt)
 {
   return duplicate_ssa_name_fn (cfun, var, stmt);
 }
@@ -138,7 +138,7 @@ release_ssa_name (tree name)
    in function cfun.  Arrange so that it uses NAME in dumps.  */
 
 static inline tree
-make_temp_ssa_name (tree type, gimple stmt, const char *name)
+make_temp_ssa_name (tree type, gimple *stmt, const char *name)
 {
   tree ssa_name;
   gcc_checking_assert (TYPE_P (type));
diff --git a/gcc/tree-stdarg.c b/gcc/tree-stdarg.c
index 1cdf0ed..84b585e 100644
--- a/gcc/tree-stdarg.c
+++ b/gcc/tree-stdarg.c
@@ -127,7 +127,7 @@ va_list_counter_bump (struct stdarg_info *si, tree counter, tree rhs,
 		      bool gpr_p)
 {
   tree lhs, orig_lhs;
-  gimple stmt;
+  gimple *stmt;
   unsigned HOST_WIDE_INT ret = 0, val, counter_val;
   unsigned int max_size;
 
@@ -545,7 +545,7 @@ check_all_va_list_escapes (struct stdarg_info *si)
 	  tree lhs;
 	  use_operand_p uop;
 	  ssa_op_iter soi;
-	  gimple phi = gsi_stmt (i);
+	  gimple *phi = gsi_stmt (i);
 
 	  lhs = PHI_RESULT (phi);
 	  if (virtual_operand_p (lhs)
@@ -573,7 +573,7 @@ check_all_va_list_escapes (struct stdarg_info *si)
 
       for (i = gsi_start_bb (bb); !gsi_end_p (i); gsi_next (&i))
 	{
-	  gimple stmt = gsi_stmt (i);
+	  gimple *stmt = gsi_stmt (i);
 	  tree use;
 	  ssa_op_iter iter;
 
@@ -730,7 +730,7 @@ pass_stdarg::execute (function *fun)
 
       for (i = gsi_start_bb (bb); !gsi_end_p (i); gsi_next (&i))
 	{
-	  gimple stmt = gsi_stmt (i);
+	  gimple *stmt = gsi_stmt (i);
 	  tree callee, ap;
 
 	  if (!is_gimple_call (stmt))
@@ -853,7 +853,7 @@ pass_stdarg::execute (function *fun)
 
 	  for (i = gsi_start_phis (bb); !gsi_end_p (i); gsi_next (&i))
 	    {
-	      gimple phi = gsi_stmt (i);
+	      gimple *phi = gsi_stmt (i);
 	      lhs = PHI_RESULT (phi);
 
 	      if (virtual_operand_p (lhs))
@@ -887,7 +887,7 @@ pass_stdarg::execute (function *fun)
 	   !gsi_end_p (i) && !va_list_escapes;
 	   gsi_next (&i))
 	{
-	  gimple stmt = gsi_stmt (i);
+	  gimple *stmt = gsi_stmt (i);
 
 	  /* Don't look at __builtin_va_{start,end}, they are ok.  */
 	  if (is_gimple_call (stmt))
